" REQUIREMENTS:
" vim (>= 6)
"
if !exists("g:ltags_command")
   let g:ltags_command = "ltags *.tex *.bib *.sty"
endif

" Menu entries
menu lt&xTools.xdvi <Esc>:let dviv=inputdialog("Numele fişierului dvi?")<CR>:execute "!xdvi -editor "'"gvim --servername xdvi --remote +\%l \%f"'" -name xdvi -sourceposition " . "'" . line(".") . " " . expand("%") . "'" . " " . "'".dviv.".dvi'" . "&"<CR>
menu lt&xTools.kdvi <Esc>:let dvik=inputdialog("Numele fişierului dvi?")<CR>:execute "!kdvi file:".dvik.".dvi" . "\\#src:" . "'" . line(".") . " " . expand("%") . "' &"<CR>
menu lt&xTools.ltags  :exe "!" . g:ltags_command<CR>
nmenu <silent> lt&xTools.ltxSect :call ActualizeazaMenu()<CR>
menu lt&xTools.selInHref xi\href{}{<Esc>pa}
"Numara cuvintele din fisier
menu lt&xTools.nrCuvinte g<C-G>
menu lt&xTools.selInGhilimele xi „<Esc>pa“
menu lt&xTools.selInEm xi{\em <Esc>pa}
menu lt&xTools.selInVerb xi\verb#<Esc>pa#
menu lt&xTools.selInVerbLine xi\verb\|<Esc>pa\|\\
menu lt&xTools.selInPar<> xi\textless{}<Esc>pa\textgreater{}
menu lt&xTools.selInComanda xi\{<Esc>pa}
menu lt&xTools.selInMbox xi\mbox{<Esc>pa}
menu lt&xTools.selTextbf xi\textbf{<Esc>pa}
menu lt&xTools.selTexttt xi\texttt{<Esc>pa}
menu lt&xTools.selTextsc xi\textsc{<Esc>pa}
menu lt&xTools.selTextsf xi\textsf{<Esc>pa}
menu lt&xTools.selTextit xi\textit{<Esc>pa}
menu lt&xTools.selCuvIdx xi\ci{<Esc>pa}
menu lt&xTools.selNtmIdx xi\mi{<Esc>pa}

" Update the S-LaTex menu, that holds chapters and sections
function! ActualizeazaMenu()
  let restore_fe = &foldenable
  set nofoldenable
  let cline=line('.')
  call MakeChapStructure ()
  call MakeSecStructure ()
  call MakeSubSecStructure ()
  call MakeSubSubSecStructure ()
  call MakeParStructure ()
  call MakeSubParStructure ()
  execute "normal ".cline."Gzz"
  let &foldenable = restore_fe
endfunction

" Make a menu that holds all of the chapters
function! MakeChapStructure () 
  norm mpgg0
  while line(".") <= line("$")
    if match ( getline("."), '^\s*\\chapter' ) != -1
      norm j
      if match ( getline("."), '^\s*\\label{sec:' ) != -1
	norm ^3w"ny3w
      elseif match ( getline("."), '^\s*\\label{' ) != -1
	norm ^3w"nyw
      endif
      let name=@n
      "exe 'menu S-LaTeX.chapters.'.name.' '.line(".").'gg15zo'
      exe 'menu S-LaTeX.chapters.'.name.' :call <SID>JumpToAndUnfold('.line(".").')<CR>'
    endif
    if line(".") == line("$")
      return
    endif
    norm j
  endwhile
  norm 'p
endfunction

" Make a menu that holds all of the function definitions
function! MakeSecStructure () 
  norm mpgg0
  while line(".") <= line("$")
    if match ( getline("."), '^\s*\\section' ) != -1
      norm j
      if match ( getline("."), '^\s*\\label{sec:' ) != -1
	norm ^3w"ny3w
      elseif match ( getline("."), '^\s*\\label{' ) != -1
	norm ^3w"nyw
      endif
      let name=@n
      "exe 'menu S-LaTeX.sections.'.name.' '.line(".").'gg15zo'
      exe 'menu S-LaTeX.sections.'.name.' :call <SID>JumpToAndUnfold('.line(".").')<CR>'
    endif
    if line(".") == line("$")
      return
    endif
    norm j
  endwhile
  norm 'p
endfunction

" Make a menu that holds all of the function definitions
function! MakeSubSecStructure () 
  norm mpgg0
  while line(".") <= line("$")
    if match ( getline("."), '^\s*\\subsection' ) != -1
      norm j
      if match ( getline("."), '^\s*\\label{sec:' ) != -1
	norm ^3w"ny3w
      elseif match ( getline("."), '^\s*\\label{' ) != -1
	norm ^3w"nyw
      endif
      let name=@n
      "exe 'menu S-LaTeX.subsections.'.name.' '.line(".").'gg15zo'
      exe 'menu S-LaTeX.subsections.'.name.' :call <SID>JumpToAndUnfold('.line(".").')<CR>'
    endif
    if line(".") == line("$")
      return
    endif
    norm j
  endwhile
  norm 'p
endfunction

" Make a menu that holds all of the function definitions
function! MakeSubSubSecStructure () 
  norm mpgg0
  while line(".") <= line("$")
    if match ( getline("."), '^\s*\\subsubsection' ) != -1
      norm j
      if match ( getline("."), '^\s*\\label{sec:' ) != -1
	norm ^3w"ny3w
      elseif match ( getline("."), '^\s*\\label{' ) != -1
	norm ^3w"nyw
      endif
      let name=@n
      "exe 'menu S-LaTeX.subsubsections.'.name.' '.line(".").'gg15zo'
      exe 'menu S-LaTeX.subsubsections.'.name.' :call <SID>JumpToAndUnfold('.line(".").')<CR>'
    endif
    if line(".") == line("$")
      return
    endif
    norm j
  endwhile
  norm 'p
endfunction

" Make a menu that holds all of the function definitions
function! MakeParStructure () 
  norm mpgg0
  while line(".") <= line("$")
    if match ( getline("."), '^\s*\\paragraph' ) != -1
      norm j
      if match ( getline("."), '^\s*\\label{sec:' ) != -1
	norm ^3w"ny3w
      elseif match ( getline("."), '^\s*\\label{' ) != -1
	norm ^3w"nyw
      endif
      let name=@n
      "exe 'menu S-LaTeX.paragraphs.'.name.' '.line(".").'gg15zo'
      exe 'menu S-LaTeX.paragraphs.'.name.' :call <SID>JumpToAndUnfold('.line(".").')<CR>'
    endif
    if line(".") == line("$")
      return
    endif
    norm j
  endwhile
  norm 'p
endfunction

" Make a menu that holds all of the function definitions
function! MakeSubParStructure () 
  norm mpgg0
  while line(".") <= line("$")
    if match ( getline("."), '^\s*\\subparagraph' ) != -1
      norm j
      if match ( getline("."), '^\s*\\label{sec:' ) != -1
	norm ^3w"ny3w
      elseif match ( getline("."), '^\s*\\label{' ) != -1
	norm ^3w"nyw
      endif
      let name=@n
      "exe 'menu S-LaTeX.subparagraphs.'.name.' '.line(".").'gg15zo'
      exe 'menu S-LaTeX.subparagraphs.'.name.' :call <SID>JumpToAndUnfold('.line(".").')<CR>'
    endif
    if line(".") == line("$")
      return
    endif
    norm j
  endwhile
  norm 'p
endfunction


function! s:JumpToAndUnfold(line)
  " Go to the right line
  execute 'normal '.a:line.'gg'
  " Check to see if we are in a fold
  let lvl = foldlevel(a:line)
  if lvl != 0
    " and if so, then expand the fold out, other wise, ignore this part.
    execute 'normal 15zo'
  endif
endfunction



